// Lots of credits are due for this collection. Zeal, Shiftre, Bob, and many others have written bits and parts and entire sections. I mostly put things together and
// tweaked as needed to make things work in MH.


class MHMBase expands Mutator config(MHMayhem);


var bool Initialized;
var int AmpCount;
var int kakuCount;
var int HealthCount;

// There is a good explanation in the ini file for these config lines

var config bool EnableMayhem;
var config int AmpSpawnTime;
var config int RedeemerSpawnTime;
var config int HealthAwardTime;
var config bool bUseRandomWeapon;
var config int HealthRegenPerSec;
var config int MaxHealth;
var config bool bUseRegenAmmo;
var config int AmmoInterval;    // One is really low interval so ammo loads fast Ten is slow twenty is dog slow
var config bool bUseRegenHealth;
var config bool bGiveArmor;
var config int MaxRegenHealth;
var config int HealthRegenPerKill;
var config bool bUseMHMTimer;
var config bool bUseMonsterHUD;
var config int DefaultHealth;
var config bool bUseAntiBoost;
var config bool bGhostCarcass;
var config String bServerInfo;
var config bool bGiveThemTrans;

var config bool bCheckMonsterAttack;
var float LastMonsterAttackTime;
var config bool stopPlayerCollision;

var string version;

var String MHMNaliFruit;
var String MHMMedBox;
var String MHMHealthPack;
var String MHMUnrealHealth;
var String MHMHealthVial;
var String MHMShieldBelt;
var String MHMUDamage;
var String MHMJumpBoots;


function PostBeginPlay()
{
        local string newhud;
	local class newclass;

	if (Initialized)
		return;

	if(CheckConfig())
	{// err
		return;
	}
	Log("*** ");
	Log("*** MHMayhem mutator is locked and loaded ");
	Log("*** ");


	Initialized = True;

	kakuCount = 0;
	HealthCount = 0;

	if(DefaultHealth < 1)
		DefaultHealth = 100;

	if(bUseMHMTimer)
		SetTimer(1, True);
	// This will add the radar and other HUD additions
	if(bUseMonsterHUD)
		Level.Game.HUDType = class'MHMHUD';
	Level.Game.RegisterDamageMutator(Self);

	TournamentGameInfo(Level.Game).GameName = (Level.Game.Default.GameName@" @"@bServerInfo);

	// fix movers and make monster ends visible
	fixmover();
	fixmymonsterend();

	if ( NextMutator != None )
		NextMutator.PostBeginPlay();

}

static function string strTrim(string source) 
{
	local int index;
	local string result;

	// remove lead spaces
	result = source;
	while (index < len(result) && mid(result, index, 1) == " ")
		index++;
	result = mid(result, index);

	// remove trail spaces
	index = len(result) - 1;
	while (index >= 0 && mid(result, index, 1) == " ")
		index--;
	result = left(result, index + 1);

	// Return new string.
	return result;
}

static function string SplitString (string ClassName, out string head, out string tail, string Sep) 
{
	local int index;

	index = instr(ClassName, Sep);
	if (index < 0) 
        {
		head = ClassName;
		tail = "";
	} 
        else
        {
		head = left(ClassName, index);
		tail = mid(ClassName, index + len(Sep));
	}
	head = strTrim (head);
	tail = strTrim (tail);

	return tail;
}

function fixmover()
{
// light fix to stop movers from crushing players ingame. Not perfect but it helps.
	local mover M;
	foreach AllActors( class 'Mover', M)
	{
		if(M.bTriggerOnceOnly && M.MoverEncroachType == ME_ReturnWhenEncroach)
		{
			//Turn this log line on to see which movers are being adjusted
                        //log("Fixed this mover to not crush players in the map:"@M.name);
			M.MoverEncroachType = ME_IgnoreWhenEncroach;
		}
	}
}

function fixmymonsterend()
{
// fix for the monster end trigger to be visible in any map
	local MonsterEnd T;
	foreach AllActors( class 'MonsterEnd', T)
	{
            if(T.bHidden == True)
		{
			T.bHidden = False;
			//Turn this line on if you want to see the replacement
                        //log("Monster End made visible:"@T.name);
		}
	}
}


function bool CheckReplacement(Actor Other, out byte bSuperRelevant)
{
        // Not a perfect system but its what we have to use. Add your custom replacements here, but take care to follow the examples. I got a lot of
        // crashes until I figured out how to correctly declare the replacements.

	if(Other.IsA('NaliFruit') && !Other.IsA('MHMNaliFruit'))
	{
			ReplaceWith(Other,MHMNaliFruit);
				return false;
	}
	//Biterfish can crash a server with the canseeme bug, this class is fixed

	if (Other.IsA('BiterFishSchool') && !Other.IsA('UMHBiterFishSchool'))
	{
		ReplaceWith(Other,"MHMayhem.UMHBiterFishSchool");
		return False;
	}
	if(Other.IsA('MedBox') && !Other.IsA('MHMMedBox'))
	{
			ReplaceWith(Other,MHMMedBox);
			return false;
	}
	if(Other.IsA('SuperHealth') || Other.IsA('HealthPack') && !Other.IsA('MHMHealthPack') && !Other.IsA('BHealthPack') && !Other.IsA('MHMUnrealHealth'))
	{
			ReplaceWith(Other,MHMHealthPack);
			return false;
	}
	if(Other.IsA('Health') && !Other.IsA('MHMHealthPack') && !Other.IsA('MHMUnrealHealth') && !Other.IsA('SuperHealth') && !Other.IsA('MHMNaliFruit'))
	{
			ReplaceWith(Other,MHMUnrealHealth);
			return false;
	}
	if(Other.IsA('HealthVial') && !Other.IsA('MHMHealthVial'))
	{
			ReplaceWith(Other,MHMHealthVial);
				return false;
	}
	//Makes carcass class see-through, you can add classes to this or make your own adjustments like this. Needs a little work as some nali are translucent when used
	//as decorations (think nali cross)

        if(Other.IsA('Carcass'))
        {
              if(bGhostCarcass)
              {
                        Other.Style = STY_Translucent;
                                return True;
              }
        }
        //Mostly these replaces are to change the spawn times and allow changes to the default properties
	if(Other.IsA('Flashlight') && !Other.IsA('MHMlight'))
	{
			ReplaceWith(Other,"MHMayhem.MHMlight");
				return false;
	}

	if(Other.IsA('JumpBoots') && !Other.IsA('MHMJumpBoots'))
	{
			ReplaceWith(Other,"MHMayhem.MHMJumpboots");
				return false;
	}

	if(Other.IsA('UT_JumpBoots') && !Other.IsA('MHMJumpBoots'))
	{
	    if(InStr ( Level.Title, "Andromeda" ) == -1)  //Stupid hack to let the people play with the everlasting jump boots
                    {
                      ReplaceWith(Other,"MHMayhem.MHMJumpBoots");
				return false;
                    }
        }

	if(Other.IsA('ShieldBelt') && !Other.IsA('MHMShieldBelt'))
	{
			ReplaceWith(Other,"MHMayhem.MHMShieldBelt");
				return false;
	}
	
	if(Other.IsA('UT_ShieldBelt') && !Other.IsA('MHMShieldBelt'))
	{
			ReplaceWith(Other,"MHMayhem.MHMShieldBelt");
				return false;
	}

	if(Other.IsA('ThighPads') && !Other.IsA('MHMThighPads'))
	{
			ReplaceWith(Other,"MHMayhem.MHMThighPads");
				return false;
	}

	if(Other.IsA('OLrifle'))   // These rifle replaces are attempting to fix the buggy U1 sniper rifle pickup, still not perfect though
	{
			ReplaceWith(Other,"Botpack.SniperRifle");
				return false;
	}
	if(Other.IsA('Rifle'))
	{
			ReplaceWith(Other,"Botpack.SniperRifle");
				return false;
	}
        if(Other.IsA('QuadShot')) //Quad has buggy graphics
	{
			ReplaceWith(Other,"Botpack.UT_FlakCannon");
				return false;
	}

	if(Other.IsA('SCUBAgear') && !Other.IsA('MHMSCUBA') )
	{
			ReplaceWith(Other,"MHMayhem.MHMSCUBA");
				return false;
	}

	if(Other.IsA('Armor2') && !Other.IsA('MHMArmor2'))
	{
			ReplaceWith(Other,"MHMayhem.MHMArmor2");
				return false;
	}
	if(Other.IsA('TournamentHealth') && !Other.IsA('BP_Health') && !Other.IsA('MedBox') && !Other.IsA('HealthPack') && !Other.IsA('HealthVial') && !Other.IsA('MHMHealthPack') && !Other.IsA('MHMHealthVial') && !Other.IsA('MHMMedBox'))
	{
			ReplaceWith(Other,"BPSE.BP_Health"); // BPSE taiou.
				return false;
	}


  bSuperRelevant = 0;
  return true;
}
function GiveAmp(Pawn PlayerPawn)
{
        //Don't reclass amp without fixing the random awards and the amp award otherwise you will
        //break the award and it will be a pickup when it spawns instead of activating on the person
	local UDamage damage;

	if( (PlayerPawn.FindInventoryType(class'UDamage') != None) ||
		(PlayerPawn.Health <= 0) )
		return;

	damage = spawn(class'UDamage',PlayerPawn,,PlayerPawn.Location);

	if( damage != None )
	{
		damage.RespawnTime = 0.0;
		damage.GiveTo(PlayerPawn);
		damage.Activate();
	}

}


function MutatorTakeDamage (out int ActualDamage,Pawn Victim,Pawn InstigatedBy,out Vector HitLocation,out Vector Momentum,name DamageType)
{
	local Pawn P;
	local float safeScore;
	
	if (InstigatedBy == none || Victim == none) return;

	if(DamageType == 'Impact') // hammer x5 ii !
	{
	   ActualDamage *= 5;
	}
	//This is a total removal of any damage or "boost" movement caused by self or other players
	if(bUseAntiBoost)
	{
		if(Victim != None && InstigatedBy != None)
		{
                      if (InstigatedBy.IsA('PlayerPawn') && Victim.IsA('PlayerPawn'))
		   {
			Momentum = Vect(0,0,0);
                        ActualDamage = 0;
                        // Special check for redeemer blast, it can pass the momentum check above and move the player
                        // even though it causes no damage
                        if (string(DamageType)=="RedeemerDeath")
                        {
			   Velocity = Vect(0,0,0);
			   Victim.Velocity = (Victim.Velocity * 0);
                        }
                   }
		}
	}

    if ( actualDamage < 0 )
        return;
    else if ( actualDamage > 1000 )
        actualDamage=1000;

    if (ActualDamage > Victim.Health)
        ActualDamage = Victim.Health;

    if ((InstigatedBy.playerReplicationInfo != None) && (InstigatedBy.bIsPlayer) && (!Victim.bIsPlayer))
        safeScore = InstigatedBy.playerReplicationInfo.Score;

    if ( NextDamageMutator != None )
        NextDamageMutator.MutatorTakeDamage(ActualDamage, Victim, InstigatedBy, HitLocation, Momentum, DamageType);

    if ( (InstigatedBy.playerReplicationInfo != None) && (TournamentPlayer(Victim) == None) &&
        (InstigatedBy.bIsPlayer) && (!Victim.bIsPlayer) ) 
    {
        // No points for Nali, cow or rabbits
    	if ( !Victim.IsA('Nali') && !Victim.IsA('Cow') && !Victim.IsA('NaliRabbit') )
             InstigatedBy.playerReplicationInfo.Score=safeScore + actualDamage;
    }
    // No points for hurting other players
    if ( Victim.IsA('ScriptedPawn') && instigatedBy.IsA('ScriptedPawn') ||
        Victim == instigatedBy && Victim.IsA('ScriptedPawn'))
        actualDamage=0;
}


function ModifyPlayer(Pawn Other)
{
	local int randm;
	local inventory inv;

	if(!Other.IsA('TournamentPlayer'))return;
        TournamentPlayer(Other).PlayerReplicationInfo.Team = 0;

	Other.Health = DefaultHealth;

	// This is the check to remove player collision and player touching lag
	if (stopPlayerCollision == true)
           Other.bBlockPlayers = false;

	// Any class can be substituted here to make a default loadout at spawn. Here are two examples:
	//DeathMatchPlus(Level.Game).GiveWeapon(Other,"Botpack.translocator");
	//DeathMatchPlus(Level.Game).GiveWeapon(Other,"Portalgunftw.shaka"); 

        // This gives players a modified trans on spawn
	if (bGiveThemTrans && Other.IsA('TournamentPlayer') )
	    {
              DeathMatchPlus(Level.Game).GiveWeapon(Other,"MHMayhem.MHMTranslocator"); //No telefrag trans
            }

	// random weapon award
	// ges,shock,pulse,ripper,mini,flak,rocket,sniper
	if (bUseRandomWeapon && Other.IsA('TournamentPlayer') ) // players only
	{
		randm = Rand(10);
		switch(randm)
		{
			case 0:
				GiveWeapon(Other,class'UT_Biorifle');
				//Other.Health += 100;
			break;
			case 1:
				GiveWeapon(Other,class'Shockrifle');
				//Other.Health += 50;
			break;
			case 2:
				GiveWeapon(Other,class'Pulsegun');
				//Other.Health += 80;
			break;
			case 3:
				GiveWeapon(Other,class'ripper');
				//Other.Health += 110;
			break;
			case 4:
				GiveWeapon(Other,class'minigun2');
				//Other.Health += 90;
			break;
			case 5:
				GiveWeapon(Other,class'UT_Flakcannon');
				//Other.Health += 30;
			break;
			case 6:
				GiveWeapon(Other,class'UT_EightBall');
				//Other.Health += 20;
			break;
			case 7:
				GiveWeapon(Other,class'MHMayhem.bSniper');
				//Other.Health += 20;
			break;
			case 8:
				GiveWeapon(Other,class'MHMayhem.bSniper');     //Custom sniper rifle
				//Other.Health += 10;
			break;
			case 9:
				GiveWeapon(Other,class'minigun2');
				//Other.Health += 400;
			break;
		}
		if(bGiveArmor)
		{
			inv = Spawn(class'Armor2');
			if( inv != None )
			{
				inv.bHeldItem = true;
				inv.RespawnTime = 0.0;
				inv.GiveTo(Other);
				inv.Charge = Inv.Default.Charge;
			}
		}
		Other.ReceiveLocalizedMessage( class'MHMGetWeaponMessage', randm, Other.PlayerReplicationInfo, Other.PlayerReplicationInfo );
	}

	if ( NextMutator != None )
		NextMutator.ModifyPlayer(Other);
}

function GiveWeapon(Pawn PlayerPawn, class<TournamentWeapon> WeaponClass )
{
	local Weapon NewWeapon;

	if( PlayerPawn.FindInventoryType(WeaponClass) != None )
		return;
	newWeapon = Spawn(WeaponClass);
	if( newWeapon != None )
	{
		newWeapon.RespawnTime = 0.0;
		newWeapon.GiveTo(PlayerPawn);
		newWeapon.bHeldItem = true;
		newWeapon.SetSwitchPriority(PlayerPawn);
		newWeapon.WeaponSet(PlayerPawn);
		newWeapon.AmbientGlow = 0;
		PlayerPawn.PendingWeapon = None;
		if ( !newWeapon.IsA('ImpactHammer') && !newWeapon.IsA('Translocator') ) 
                {
			newWeapon.GiveAmmo(PlayerPawn);
			newWeapon.AmmoType.AmmoAmount = newWeapon.AmmoType.MaxAmmo/10; // Divide by lower number for greater ammo on spawn
		}
	}
}


function ScoreKill(Pawn Killer, Pawn Other)
{
       local float safeScore;

	if(Killer == None)return;
	if(!Killer.bIsHuman)return;
	if(Killer.PlayerReplicationInfo.bIsABot) return;
	if(Killer.IsA('ScriptedPawn'))return;
	if(Killer.IsA('ScriptedPawn') && Other.IsA('ScriptedPawn'))return;
	if ( (Killer == None) && (Other == None) )return;
	if ( Killer.bIsPlayer && Other.bIsPlayer )return; // team killers
	if ( Other.Spree > 1 && Other.bIsPlayer)
	EndSpree(Killer, Other);
	if(Other.bIsPlayer)Other.Spree = 0;
        if ( (Killer != None) && Killer.bIsPlayer && (Killer != Other) )
		{
                     Killer.Health = FMax (FMin (MaxHealth, Killer.Health + HealthRegenPerKill), Killer.Health);
                     Killer.Spree+=1;
                     if ( Killer.Spree > 14 )
                     NotifySpree(Killer, Killer.Spree);
                     if ( (TournamentPlayer(Killer).Level.TimeSeconds - TournamentPlayer(Killer).LastKillTime < 3))
                            {
                                TournamentPlayer(Killer).MultiLevel++;
                                if(TournamentPlayer(Killer).MultiLevel >= 22)TournamentPlayer(Killer).MultiLevel = 21;
                                TournamentPlayer(Killer).ReceiveLocalizedMessage( class'MHMMultiKillMessage', TournamentPlayer(Killer).MultiLevel );
                                CheckBroadCast(Killer,TournamentPlayer(Killer).MultiLevel);
                            }
                     else
                            TournamentPlayer(Killer).MultiLevel = 0;
                            TournamentPlayer(Killer).LastKillTime = TournamentPlayer(Killer).Level.TimeSeconds;
                }
        safeScore = Killer.PlayerReplicationInfo.Score;
        if ( NextMutator != None )
        NextMutator.ScoreKill(Killer,Other);
        Killer.PlayerReplicationInfo.Score = safeScore;
}

function CheckBroadCast(Pawn Killer,int num)
{
	if(Killer.bIsPlayer && !Killer.PlayerReplicationInfo.bIsABot)
	BroadCastMessage(Killer.PlayerReplicationInfo.PlayerName@GetText(num));
}

function string GetText(int Switch)
{
	switch (Switch)
	{
		case 1:
			return " has Double Kill!";
			break;
		case 2:
			return " is still going... ";
			break;
		case 3:
			return " has Multi Kill!";
			break;
		case 4:
			return " is still going... ";
			break;
		case 5:
		        return " has Mega Kill!";
			break;
		case 6:
		        return " is still going... ";
			break;
                case 7:
                        return " is still going... ";
			break;
		case 8:
		        return " has ULTRA KILL!!";
			break;
		case 9:
		        return " is still going... ";
			break;
		case 10:
		        return " is still going... ";
			break;
		case 11:
		        return " is still going... ";
			break;
		case 12:
		        return " has MONSTER KILL!!";
			break;
		case 13:
		        return " is still going... ";
			break;
		case 14:
		        return " is still going... ";
			break;
		case 15:
		        return " has LUDICROUS KILL!!";
			break;
		case 16:
		        return " is still going... ";
			break;
		case 17:
		        return " is still going... ";
			break;
		case 18:
		        return " is still going... ";
			break;
		case 19:
		        return " is still going... ";
			break;
		case 20:
	         	return " is UNSTOPPABLE!!";
			break;
		case 21:
		        return " just can't be stopped!!";
			break;

	}
	return "";
}

// Change this to alter the number of kills needed to trigger the various spree awards
function NotifySpree(Pawn Other, int num)
{
	local Pawn P;

	if ( num == 30 )
		num = 0;
	else if ( num == 45 )
		num = 1;
	else if ( num == 60 )
		num = 2;
	else if ( num == 90 )
		num = 3;
	else if ( num == 125 )
		num = 4;
	else if ( num == 250 )
		num = 5;
	else
		return;

	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		if ( P.IsA('TournamentPlayer') )
			P.ReceiveLocalizedMessage( class'MHMKillingSpreeMessage', Num, Other.PlayerReplicationInfo );
}


function EndSpree(Pawn Killer, Pawn Other)
{
	local Pawn P;
	if ( !Other.bIsPlayer || Killer.PlayerReplicationInfo.bIsABot)
		return;
	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
	if ( P.IsA('TournamentPlayer') )
	{
		if(Other.IsA('ScriptedPawn'))
			P.ReceiveLocalizedMessage( class'MHMKillingSpreeMessage', Other.Spree, Killer.PlayerReplicationInfo,  Killer.PlayerReplicationInfo );
		else // pk end
			P.ReceiveLocalizedMessage( class'MHMKillingSpreeMessage', Other.Spree, Killer.PlayerReplicationInfo, Other.PlayerReplicationInfo );

	}
}

simulated function Tick (float DT)
{
    Super.Tick(DT);

    if ( Level.Game.bGameEnded ) return;

    if ((bCheckMonsterAttack) && (LastMonsterAttackTime < Level.TimeSeconds)) // call every x secs
        MonsterAttackCheck();
}

function Timer()
{

	// regenerate ammo (except redeemer) & health in one fell swoop
	local Pawn P;
	local Inventory Inv;

	if (AmpCount < AmpSpawnTime)AmpCount++;

	else if (AmpCount == AmpSpawnTime)
        {
		BroadcastLocalizedMessage( class'MHMAmpMessage',,, None, None );
		// give all current players damage amps
		for ( P=Level.PawnList; P!=None; P=P.NextPawn )
			if ( P.IsA('Bot')  || P.IsA('TournamentPlayer'))
				GiveAmp(P);
		AmpCount = 0;
	}
	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
		if ( P.IsA('Bot')  || P.IsA('TournamentPlayer'))
                {
			if (P.Health > 0)
                        {
				// ammo
				if(bUseRegenAmmo)
				{
				// This section should be rewritten to simplify it. It's unneccessarily complex
				for( Inv=P.Inventory; Inv!=None; Inv=Inv.Inventory )
					if ( (Ammo(Inv)!=None) && (P.bFire==0) && (P.bAltFire==0) )
						if (Ammo(Inv).AmmoAmount < Ammo(Inv).MaxAmmo * 10) 
                                                {
							Ammo(Inv).AmmoAmount += (Ammo(Inv).Default.AmmoAmount/ AmmoInterval);
							if (Ammo(Inv).AmmoAmount > Ammo(Inv).MaxAmmo * 10)
								Ammo(Inv).AmmoAmount = Ammo(Inv).MaxAmmo * 10;
						}
				}

				if(bUseRegenHealth)
				{
				// health
				if ( P.Health < MaxRegenHealth && !P.Region.Zone.bWaterZone)       // waterzone stoppage of health regen, otherwise players cannot drown
				P.Health = FMin(MaxRegenHealth, P.Health + HealthRegenPerSec);
				}

			}

               }

 //random Trans & health

    P = GetRandomPlayer();
    if(P != None)
    {
        if (kakuCount < RedeemerSpawnTime)kakuCount ++;
  	if (HealthCount < HealthAwardTime)HealthCount ++;
        if(RedeemerSpawnTime-kakuCount < 5 &&  RedeemerSpawnTime-kakuCount > 0)
        {
         BroadcastLocalizedMessage(class'MHMRandomDeemerMsg',RedeemerSpawnTime-kakuCount,P.PlayerReplicationInfo  );
        }
	if(HealthAwardTime-HealthCount < 5 && HealthAwardTime-HealthCount > 0)
	{
   	 BroadcastLocalizedMessage(class'MHMRandomHealthMsg',HealthAwardTime-HealthCount,P.PlayerReplicationInfo  );
   	}
        if (kakuCount >= RedeemerSpawnTime)
        {
   	     kakuCount = 0;
             P = GetRandomPlayer();
             if(P.bIsPlayer)
             {
               BroadcastLocalizedMessage(class'MHMRandomDeemerMsg',kakuCount,P.PlayerReplicationInfo  );
               GiveRedeemer(P);
             }
        }
        if (HealthCount >= HealthAwardTime)
        {
	     HealthCount = 0;
             P = GetRandomPlayer();
             if(P.bIsPlayer)
             {
               BroadcastLocalizedMessage(class'MHMRandomHealthMsg',HealthCount,P.PlayerReplicationInfo  );
               GiveHealth(P);
             }
	}

    }

}

function MonsterAttackCheck()
// Stops monsters fighting among themselves. May make them act a little frozen or repeating until they acquire a player as a target.
{
    local ScriptedPawn S;

    foreach AllActors(class'ScriptedPawn', S) {
        if (S.Enemy != None && S.Enemy.IsA('ScriptedPawn')) {
            S.Hated = None;
            S.Enemy = None;
            if (S.OldEnemy!=None && S.OldEnemy.IsA('ScriptedPawn'))
                S.OldEnemy = none;
            S.WhatToDoNext('Waiting','');  // let the AI have some say in what state they return to
        }
    }

    LastMonsterAttackTime = Level.TimeSeconds;
}


function GiveRedeemer(Pawn PlayerPawn)
{
        //This is the random redeemer award. You can subclass here to use a custom deemer for the award if you choose. Extra redeemer classes are included in the source
        //and can be plugged in here. Just add the classes and change the spawn(class line to the new redeemer class
	local Warheadlauncher  rede;
	rede= spawn(class'Warheadlauncher');

	if( rede!= None )
	{
        rede.RespawnTime = 0.0;
        rede.GiveTo(PlayerPawn);
        rede.SetSwitchPriority(PlayerPawn);
	PlayerPawn.AddInventory(rede);
        rede.PickupAmmoCount = 1;
	rede.GiveAmmo(PlayerPawn);
	}
}

// This is the random health award, but could be called for other things too
function GiveHealth(Pawn PlayerPawn)
{
	PlayerPawn.Health+=500;
}

function Pawn GetRandomPlayer() 
{
  local Pawn N;
  local PlayerPawn Dest;
  local Pawn Candidate[32];
  local int num;

  for (N=Level.PawnList; N!=None; N=N.NextPawn) 
  {
    Dest=PlayerPawn(N);
    if (Dest!=None && Dest.bIsPlayer && !Dest.PlayerReplicationInfo.bIsSpectator) 
    {
      if (num<32) Candidate[num] = Dest;
      else if (Rand(num) < 32) Candidate[Rand(32)] = Dest;
      num++;
    }
  }

  if(num==0) return None;
  return Candidate[Rand(Min(32,num))];
}

    //Not really needed but you can add logging entries here for things you'd like to follow in the server log
function bool CheckConfig()
{
	if(!EnableMayhem)return true;
	Log("---  Config  ---");
	Log("---  It's all good  ---");
	return false;
}

// Def props are explained in the ini file that accompanies the mod
defaultproperties
{
     EnableMayhem=True
     AmpSpawnTime=300
     RedeemerSpawnTime=361
     HealthAwardTime=920
     bUseRandomWeapon=True
     HealthRegenPerSec=10
     MaxHealth=250
     bUseRegenAmmo=True
     bUseRegenHealth=True
     bGiveArmor=True
     MaxRegenHealth=250
     HealthRegenPerKill=10
     bUseMHMTimer=True
     bUseMonsterHUD=True
     DefaultHealth=200
     bUseAntiBoost=False
     bGhostCarcass=True
     bCheckMonsterAttack=True
     stopPlayerCollision=True
     bGiveThemTrans=True
     version="MHMayhem"
     MHMNaliFruit="MHMayhem.MHMNaliFruit"
     MHMMedBox="MHMayhem.MHMMedBox"
     MHMHealthPack="MHMayhem.MHMHealthPack"
     MHMUnrealHealth="MHMayhem.MHMUnrealHealth"
     MHMHealthVial="MHMayhem.MHMHealthVial"
}
