//Custom HUD reclass. If you can do better, fix it :P

class MHMHUD expands ChallengeTeamHUD;


#exec TEXTURE IMPORT NAME=MHudIcon  FILE=Textures\HUDIconMHM.bmp GROUP="Hud" MIPS=OFF LODSET=0
#exec TEXTURE IMPORT NAME=MBlackStuff  FILE=Textures\BlackStuff.bmp GROUP="Hud" MIPS=OFF LODSET=0
#exec TEXTURE IMPORT NAME=MBlackStuff2  FILE=Textures\BlackStuff2.bmp GROUP="Hud" MIPS=OFF LODSET=0
#exec Texture Import File=Textures\radarconsole.bmp Name=radarconsole Mips=Off Flags=2
#exec Texture Import File=Textures\Monsterpoint.pcx Name=monsterpoint Mips=Off

// This is the radar render section. To move the radar around the HUD change the Position setting in default properties
// to match one of these settings. It would be easy to make it settable via the ini file, but I'd rather keep control
// of the HUD placement inside the script.
var texture tex;
var() config enum ES_Position 
{
	RADAR_TopLeft,
	RADAR_TopMiddle,
	RADAR_TopRight,
	RADAR_MiddleLeft,
	RADAR_MiddleRight,
	RADAR_BottomLeft,
	RADAR_BottomMiddle,
	RADAR_BottomRight
} Position;
var PlayerPawn Player;

var() config int Zscale;
var bool bActive;
var GameReplicationInfo GRI;

simulated function PostBeginPlay ()
{

	Super.PostBeginPlay();
	bUseTeamColor=MonsterReplicationInfo(PlayerPawn(Owner).GameReplicationInfo).bUseTeamSkins;
}

simulated function DrawGameSynopsis(Canvas Canvas)
{
	local float XL, YL, XOffset, YOffset;
	local inventory Inv;
	local int BootCharges;
	local int FlashCharges;

	if ( (PawnOwner.PlayerReplicationInfo == None)
		|| PawnOwner.PlayerReplicationInfo.bIsSpectator )
		return;

	Canvas.Font = MyFonts.GetBigFont( Canvas.ClipX );
	Canvas.DrawColor = GoldColor;

	Canvas.StrLen(RankString, XL, YL);
	if ( bHideAllWeapons )
		YOffset = Canvas.ClipY - YL*3;
	else if ( HudScale * WeaponScale * Canvas.ClipX <= Canvas.ClipX - 256 * Scale )
		YOffset = Canvas.ClipY - 64*Scale - YL*3;
	else
		YOffset = Canvas.ClipY - 128*Scale - YL*3;
	if (MonsterReplicationInfo(PlayerPawn(Owner).GameReplicationInfo).bUseLives)
	{
		Canvas.SetPos(0, YOffset);
		Canvas.DrawText(" Lives Left: "$int(PawnOwner.PlayerReplicationInfo.Deaths), False);
	}
	for ( Inv=PawnOwner.Inventory; Inv!=None; Inv=Inv.Inventory )
           {
           if ( Inv.IsA('MHMSCUBA'))
          {
            if((Inv.Charge/10) < 25) Canvas.DrawColor = RedColor;

 	    Canvas.SetPos(0, YOffset - YL);
	    Canvas.DrawText(" SCUBA: "@(Inv.Charge/10), False);
	    Canvas.DrawColor = GoldColor;
	  }
	  if ( Inv.IsA('MHMJumpBoots')) //  || Inv.IsA('UT_Jumpboots') )    Nulled other checks
		{
			BootCharges=Inv.Charge;
			Canvas.SetPos(0, YOffset - YL - YL);
	                Canvas.DrawText(" Jumps left: "@Inv.Charge, False);

		}
	  if ( Inv.IsA('MHMlight'))
	        {
			FlashCharges=Inv.Charge;
                        if((Inv.Charge/10) < 100) Canvas.DrawColor = RedColor;
			Canvas.SetPos(0, YOffset - YL - YL-YL);
	                Canvas.DrawText(" Flashlight: "@(Inv.Charge/10), False);
	                Canvas.DrawColor = GoldColor;

		}

	  }
	Canvas.SetPos(0, YOffset + YL);
	Canvas.DrawText(" Team Size: "$string(MonsterReplicationInfo(PlayerPawn(Owner).GameReplicationInfo).Hunters), False);
	if ((MonsterReplicationInfo(PlayerPawn(Owner).GameReplicationInfo).Monsters) < 10) Canvas.DrawColor = RedColor;
        Canvas.SetPos(0, YOffset + YL + YL);
	Canvas.DrawText(" Monsters Left: "$string(MonsterReplicationInfo(PlayerPawn(Owner).GameReplicationInfo).Monsters), False);
	Canvas.DrawColor = GoldColor;
}

simulated function DrawFragCount (Canvas Canvas)
{
	local float Whiten;
	local int X;
	local int Y;

	if ( PawnOwner.PlayerReplicationInfo == None )
	{
		return;
	}
	Canvas.Style=Style;
	if ( bHideAllWeapons || (HUDScale * WeaponScale * Canvas.ClipX <= Canvas.ClipX - 256 * Scale) )
	{
		Y=Canvas.ClipY - 63.50 * Scale;
	}
	else
	{
		Y=Canvas.ClipY - 127.50 * Scale;
	}
	if ( bHideAllWeapons )
	{
		X=0.50 * Canvas.ClipX - 256 * Scale;
	}
	Canvas.CurX=X;
	Canvas.CurY=Y;
	Canvas.DrawColor=HUDColor;
	Whiten=Level.TimeSeconds - ScoreTime;
	if ( Whiten < 3.00 )
	{
		if ( HUDColor==GoldColor )
		{
			Canvas.DrawColor=WhiteColor;
		}
		else
		{
			Canvas.DrawColor=GoldColor;
		}
		if ( Level.bHighDetailMode )
		{
			Canvas.CurX=X - 64 * Scale;
			Canvas.CurY=Y - 32 * Scale;
			Canvas.Style=3;
			Canvas.DrawTile(Texture'HUDWeapons',256.00 * Scale,128.00 * Scale,0.00,128.00,256.00,128.00);
		}
		Canvas.CurX=X;
		Canvas.CurY=Y;
		Whiten=4.00 * Whiten - 4 * Whiten;
		Canvas.DrawColor=Canvas.DrawColor + (HUDColor - Canvas.DrawColor) * Whiten;
	}
	Canvas.DrawTile(Texture'HudElements1',128.00 * Scale,64.00 * Scale,0.00,128.00,128.00,64.00);
	Canvas.DrawColor=WhiteColor;

    if (int(PawnOwner.PlayerReplicationInfo.Score) >= 9999) {
    	Canvas.SetPos(X + 10 * Scale,Y + 16 * Scale);
    	Canvas.Font=MyFonts.GetHugeFont(Canvas.ClipX);
    	Canvas.DrawText(int(PawnOwner.PlayerReplicationInfo.Score));
    }
    else
	   DrawBigNum(Canvas, int(PawnOwner.PlayerReplicationInfo.Score), X + 40 * Scale, Y + 16 * Scale);
}

simulated function DrawAmmo(Canvas Canvas)
{
    local int X,Y;

    Canvas.Style = Style;
    Canvas.DrawColor = HUDColor;
    if ( bHideAllWeapons || (HudScale * WeaponScale * Canvas.ClipX <= Canvas.ClipX - 256 * Scale) )
        Y = Canvas.ClipY - 63.5 * Scale;
    else
        Y = Canvas.ClipY - 127.5 * Scale;
    if ( bHideAllWeapons )
        X = 0.5 * Canvas.ClipX + 128 * Scale;
    else
        X = Canvas.ClipX - 128 * Scale;
    Canvas.SetPos(X, Y);
    Canvas.DrawTile(Texture'BotPack.HudElements1', 128*Scale, 64*Scale, 128, 192, 128.0, 64.0);

    if ( (PawnOwner.Weapon == None) || (PawnOwner.Weapon.AmmoType == None) )
        return;

    Canvas.DrawColor = WhiteColor;

    if (PawnOwner.Weapon.AmmoType.AmmoAmount <= 999)
        DrawBigNum(Canvas, PawnOwner.Weapon.AmmoType.AmmoAmount, X + 8 * Scale, Y + 16 * Scale);
    else {
        Canvas.Font=MyFonts.GetHugeFont(Canvas.ClipX);
        Canvas.SetPos(X + 10 * Scale,Y + 16 * Scale);
        Canvas.DrawText(PawnOwner.Weapon.AmmoType.AmmoAmount);
    }
}


simulated function DrawStatus(Canvas Canvas)
{
	local float X, Y;

	Super.DrawStatus(Canvas);

	Canvas.DrawColor = HUDColor;
	if ( bHideStatus && bHideAllWeapons )
	{
		X = 0.5 * Canvas.ClipX - 128 * Scale;
		Y = Canvas.ClipY - 64 * Scale;
	}
	else
	{
		X = Canvas.ClipX - 128 * Scale * StatusScale - 140 * Scale;
		Y = 128 * Scale;
	}

	Canvas.SetPos(X, Y);
	Canvas.DrawTile(Texture'MonsterHunt.Hud.MHudIcon', 128*Scale, 64*Scale, 0, 192, 128.0, 64.0);

}

simulated function Message( PlayerReplicationInfo PRI, coerce string Msg, name MsgType )
{
	local int i;
	local Class<LocalMessage> MessageClass;

	switch (MsgType)
	{
		case 'Say':
			MessageClass = class'SayMessagePlus';
			break;
		case 'TeamSay':
			MessageClass = class'TeamSayMessagePlus';
			break;
		case 'CriticalEvent':
			MessageClass = class'CriticalStringPlus';
			LocalizedMessage( MessageClass, 0, None, None, None, Msg );
			return;

		case 'MonsterCriticalEvent':
			MessageClass = class'MonsterCriticalString';
			LocalizedMessage( MessageClass, 0, None, None, None, Msg );
			return;

		case 'DeathMessage':
			MessageClass = class'RedSayMessagePlus';
			break;
		case 'Pickup':
			PickupTime = Level.TimeSeconds;
		default:
			MessageClass = class'StringMessagePlus';
			break;
	}

	if ( ClassIsChildOf(MessageClass, class'SayMessagePlus') || 
				     ClassIsChildOf(MessageClass, class'TeamSayMessagePlus') )
	{
		FaceTexture = PRI.TalkTexture;
		FaceTeam = TeamColor[PRI.Team];
		if ( FaceTexture != None )
			FaceTime = Level.TimeSeconds + 3;
		if ( Msg == "" )
			return;
	} 

	for (i=0; i<4; i++)
	{
		if ( ShortMessageQueue[i].Message == None )
		{
			// Add the message here.
			ShortMessageQueue[i].Message = MessageClass;
			ShortMessageQueue[i].Switch = 0;
			ShortMessageQueue[i].RelatedPRI = PRI;
			ShortMessageQueue[i].OptionalObject = None;
			ShortMessageQueue[i].EndOfLife = MessageClass.Default.Lifetime + Level.TimeSeconds;
			if ( MessageClass.Default.bComplexString )
				ShortMessageQueue[i].StringMessage = Msg;
			else
				ShortMessageQueue[i].StringMessage = MessageClass.Static.AssembleString(self,0,PRI,Msg);
			return;
		}
	}

	// No empty slots.  Force a message out.
	for (i=0; i<3; i++)
		CopyMessage(ShortMessageQueue[i], ShortMessageQueue[i+1]);

	ShortMessageQueue[3].Message = MessageClass;
	ShortMessageQueue[3].Switch = 0;
	ShortMessageQueue[3].RelatedPRI = PRI;
	ShortMessageQueue[3].OptionalObject = None;
	ShortMessageQueue[3].EndOfLife = MessageClass.Default.Lifetime + Level.TimeSeconds;
	if ( MessageClass.Default.bComplexString )
		ShortMessageQueue[3].StringMessage = Msg;
	else
		ShortMessageQueue[3].StringMessage = MessageClass.Static.AssembleString(self,0,PRI,Msg);
}

simulated function DrawMBlackStuff( canvas Canvas )
{
	Canvas.DrawColor = WhiteColor;
	Canvas.Style = ERenderStyle.STY_Modulated;

	Canvas.SetPos(0, 0);
	Canvas.DrawTile(Texture'MHMayhem.Hud.MBlackStuff', Canvas.ClipX, 160*Scale, 0, 0, 16, 64);
	Canvas.SetPos(0, Canvas.ClipY - (160*Scale));
	Canvas.DrawTile(Texture'MHMayhem.Hud.MBlackStuff2', Canvas.ClipX, 160*Scale, 0, 0, 16, 64);

	Canvas.Style = ERenderStyle.STY_Translucent;
}

// This is the black bars spectators get. I was tempted to null this, its buggy with nexgen.
simulated function PostRender( canvas Canvas )
{
	HUDSetup(canvas);
	if ( (PawnOwner == None) || (PlayerOwner.PlayerReplicationInfo == None) )
		return;

	if ( MonsterReplicationInfo(PlayerPawn(Owner).GameReplicationInfo).bUseLives
	     && (PawnOwner.PlayerReplicationInfo.Deaths < 1) && !PawnOwner.IsA('Spectator'))
		DrawMBlackStuff(Canvas);

	super.PostRender(Canvas);
	DrawMonsterName(Canvas);
	DrawRadar(Canvas);
}

simulated function DrawMonsterName(Canvas C)
{

	local float Dist;
	local ScriptedPawn P;
	local MonsterEnd finishline;
	local int XPos, YPos;
	local Vector X,Y,Z, Dir;
	local PlayerPawn C_Owner;

//	C_Owner = PlayerPawn(Owner.Owner);
	C_Owner = PlayerPawn(Owner);
	GetAxes(C_Owner.Rotation, X, Y, Z);

	if (Level.bHighDetailMode)
		C.Style = ERenderStyle.STY_Translucent;
	else
		C.Style = ERenderStyle.STY_Normal;
	foreach VisibleCollidingActors(class'ScriptedPawn', P, 2500, C_Owner.Location, true)
        {
		Dir = P.Location - C_Owner.Location;
		Dist = VSize(Dir);
		Dir = Dir / Dist;
		if ((Dir Dot X) > 0.7) 
                {
			XPos = 0.5 * C.ClipX * (1 + 1.4 * (Dir Dot Y));
			YPos = 0.5 * C.ClipY * (1 - 1.4 * (Dir Dot Z));
			C.SetPos(XPos - 8, YPos - 8);
			C.DrawIcon(Texture'CrossHair5', 1.0);
			C.SetPos(Xpos - 12, YPos - 16);

			C.DrawColor.R = 0;
			C.DrawColor.G = 255;
			C.DrawColor.B = 0;


			if(P.Health < (P.Default.Health * 0.3) ) //30% dam
			{
				C.DrawColor.R = 255;
				C.DrawColor.G = 0;
				C.DrawColor.B = 0;
			}
			else if(P.Health < (P.Default.Health * 0.6) ) //60% dam
			{
				C.DrawColor.R = 255;
				C.DrawColor.G = 255;
				C.DrawColor.B = 0;
			}
			else if(P.Health < (P.Default.Health * 0.9) ) //90% dam
			{
				C.DrawColor.R = 127;
				C.DrawColor.G = 255;
				C.DrawColor.B = 0;
			}
                 	//C.Font = C.SmallFont;    // Another font that is smaller if you so choose, just null the other and use this
			C.Font = C.MedFont;
			C.SetPos(Xpos - 12, YPos - 16);
			C.DrawText("("$P.Health$")", true);
			//log(P.class.Name$"("$P.Health$")"$" C_Owner.Location:"$C_Owner.Location);  //check log for seen monsters, will flood the logs though if you use

		}
	}

}


simulated function drawRadar(canvas Canvas) 
{
        local ScriptedPawn monster;
	local int index, radius;
	local int originX, originY;

	if(!Owner.IsA('PlayerPawn')) 
        {
		Log("Owner: ("$Owner$") does not want me loaded", Class.Name);
		return;
	}

	Canvas.Reset();
	
	radius = Canvas.sizeY/16;


        switch(Position) 
        {
	case RADAR_TopLeft:
		originX = 10;
		originY = 10;
		break;
	case RADAR_TopMiddle:
		originX = Canvas.SizeX/2 - radius;
		originY = 10;
		break;
	case RADAR_TopRight:
		originX = Canvas.SizeX - radius*2 - 10;
		originY = 10;
		break;
	case RADAR_MiddleLeft:
		originX = 10;
		originY = Canvas.SizeY/2 - radius;
		break;
	case RADAR_MiddleRight:
		originX = Canvas.SizeX - radius - 80;
		originY = Canvas.SizeY/2 - radius;
		break;
	case RADAR_BottomLeft:
		originX = 10;
		originY = Canvas.SizeY - radius*2 - 10;
		break;
	case RADAR_BottomMiddle:
		originX = Canvas.SizeX/2 - radius;
		originY = Canvas.SizeY - radius*2 - 10;
		break;
	case RADAR_BottomRight:
		originX = Canvas.SizeX - radius*2 - 10;
		originY = Canvas.SizeY - radius*2 - 10;
		break;
	}
        Canvas.Style = ERenderStyle.STY_Translucent;    // New attempt at transparency. This is very light and unobtrusive but you can adjust it to be
	Canvas.SetPos(originX, originY);                // as bright as you would like.
	Canvas.DrawTile(tex, radius*2, radius*2, 0, 0, 128, 128);

	foreach AllActors(class'ScriptedPawn', Monster) 
        {
		if(Monster.Health <= 0) continue;
		drawBlip(Monster, Canvas, originX, originY, radius);
	}
}

simulated function drawBlip(Pawn other, canvas Canvas, int originX, int originY, int radius) 
{
	local rotator myRotation, monsterRotation, blipRotation;
	local int x, y, monsterDistance;
	local Vector point, myLocation, monsterLocation;
	local Weapon weapon;
	local PlayerPawn pOwner;

	if(other.Health <= 0) {
                Canvas.DrawColor.R = 255;
		Canvas.DrawColor.G = 0;
		Canvas.DrawColor.B = 0;
	} else {
                Canvas.DrawColor.R = 255;
		Canvas.DrawColor.G = 255;
		Canvas.DrawColor.B = 255;
	}
//Error logging
	if(Owner == none) {
		Log("draw MonsterPoint: I don't have an owner!", Class.Name);
		return;
	}

	pOwner = PlayerPawn(Owner);
	if(pOwner == none) {
		Log("draw Monster Point: pOwner is null!", Class.Name);
		return;
	}
	
	if(Canvas == none || other == none) {
		Log("draw Monster Point: Canvas: "$Canvas$", other: "$other, Class.Name);
		return;
	}

	weapon = pOwner.Weapon;
	if(Weapon != none && Weapon.IsA('WarheadLauncher') &&
	   WarheadLauncher(Weapon).bGuiding &&
	   WarheadLauncher(Weapon).GuidedShell != none) {
		myLocation = WarheadLauncher(Weapon).GuidedShell.Location;
	} else {
		myLocation = Owner.Location;
	}
	myLocation.z = 0;

	myRotation = pOwner.ViewRotation;
	myRotation.Yaw  += 16384;
	myRotation.Pitch = 0;
	myRotation.Roll  = 0;

	monsterLocation   = other.Location;
	monsterLocation.z = 0;
	point = myLocation - monsterLocation;
	monsterDistance = VSize(point);
	monsterRotation = rotator(point);
	monsterRotation.Pitch = 0;
	monsterRotation.Roll  = 0;

	blipRotation = myRotation - monsterRotation;

	point = monsterDistance * vector(blipRotation);

	if(VSize(point) < radius*50)
        {
                point.x = -point.x / 50 + radius + originX;
		point.y = point.y / 50 + radius + originY;
        	Canvas.SetPos(point.x, point.y);
		Canvas.DrawTile(Texture'MHMayhem.monsterpoint', 2, 2, 0, 0, 2, 2); // Change your blip color here. You might add one for players too
	}
}

function setZscale(int value)    // This is for the "zoom" of the radar. Adjust it to let it "see" farther, though in testing 50 was the optimal setting
{
	if(value < 1) value = 1;
	scale = value;
}

simulated function DrawInfo(canvas Canvas)
{
	local vector HitLocation, HitNormal, StartTrace, EndTrace, X,Y,Z;
	local actor Other;
	local Pawn PawnOwner;
	local rotator AdjustedAim;

	PawnOwner = Pawn(Owner);

	GetAxes(PawnOwner.ViewRotation,X,Y,Z);

	StartTrace  = Owner.Location + PawnOwner.Eyeheight * Z; 
	AdjustedAim = PawnOwner.AdjustAim(1000000, StartTrace, 0, False, False);	
	X           = vector(AdjustedAim);
	EndTrace    = StartTrace + 10000 * X; 
	Other       = PawnOwner.TraceShot(HitLocation,HitNormal,EndTrace,StartTrace);

	ProcessTrace(Canvas, Other);
}

simulated function ProcessTrace(canvas Canvas, Actor Other) 
{
	local int originX, originY;
	local Pawn pawnOther;

	originX   = Canvas.SizeX / 2 - 100;
	originY   = Canvas.SizeY / 2 + 100;

	if(Other == none || !Other.IsA('ScriptedPawn')) return;

	Canvas.Reset();

	Canvas.DrawColor.R = 255;
	Canvas.DrawColor.G = 255;
	Canvas.DrawColor.B = 255;
	Canvas.Font        = Canvas.smallFont;

	pawnOther = Pawn(Other);

	Canvas.setPos(originX, originY);
	Canvas.drawText("Name: " $ pawnOther.getHumanName());
	Canvas.setPos(originX, originY+10);
	Canvas.drawText("Health: " $ pawnOther.Health);
}

defaultproperties
{
     Zscale=50                        // This sets the "zoom" or how far away it can see
     tex=Texture'radarconsole'       // Change this to make your own radar display
     Position=RADAR_MiddleRight      // HUD position change
     bAlwaysRelevant=True
     bNetTemporary=True
     RemoteRole=ROLE_SimulatedProxy
}


