// Alters respawn time but you can also change anything else. Charge is the number of jumps in the boots
// Also the last half-jump is fixed

class MHMJumpBoots extends UT_JumpBoots;

#exec AUDIO IMPORT FILE="Sounds\Boing1.wav" NAME=Boing1

var int TimeCharge;

function PickupFunction(Pawn Other)
{
    TimeCharge = 0;
    SetTimer(1.0, True);
}

function ResetOwner()
{
    local pawn P;

    P = Pawn(Owner);
    P.JumpZ = P.Default.JumpZ * Level.Game.PlayerJumpZScaling();
    if ( Level.Game.IsA('DeathMatchPlus') )
        P.AirControl = DeathMatchPlus(Level.Game).AirControl;
    else
        P.AirControl = P.Default.AirControl;
    P.bCountJumps = False;
}

function OwnerJumped()
{
    if ( !Pawn(Owner).bIsWalking )
    {
        TimeCharge=0;
        if ( Charge <= 0 ) 
        {
            if ( Owner != None )
            {
                Owner.PlaySound(DeActivateSound);
                ResetOwner();                       
            }       
            UsedUp();
        }
        else
            Owner.PlaySound(sound'Boing1');
        Charge -= 1;
    }
    if( Inventory != None )
        Inventory.OwnerJumped();

}

function Timer()
{
    if ( Charge <= 0 ) 
    {
        if ( Owner != None )
        {
            if ( Owner.Physics == PHYS_Falling )
            {
                SetTimer(0.3, true);
                return;
            }
            Owner.PlaySound(DeActivateSound);
            ResetOwner();                       
        }       
        UsedUp();
        return;
    }

    if ( !Pawn(Owner).bAutoActivate )
    {   
        TimeCharge++;
        if (TimeCharge>20)
        {
            OwnerJumped();
            TimeCharge = 0;
        }
    }
}

state Activated
{
    function endstate()
    {
        ResetOwner();
        bActive = false;        
    }
Begin:
    Pawn(Owner).bCountJumps = True;
    Pawn(Owner).AirControl = 1.0;
    Pawn(Owner).JumpZ = Pawn(Owner).Default.JumpZ * 3;
    Owner.PlaySound(ActivateSound);     
}

state DeActivated
{
Begin:      
}

defaultproperties
{
     ExpireMessage="The Jump Boots have drained."
     bActivatable=True
     bAutoActivate=True
     bDisplayableInv=True
     PickupMessage="You picked up the Jump boots."
     RespawnTime=2.000000
     PickupViewMesh=Mesh'Botpack.jboot'
     Charge=4
     PickupSound=Sound'Unrealshare.Pickups.GenPickSnd'
     ActivateSound=Sound'Botpack.Pickups.BootSnd'
     Icon=Texture'UnrealI.Icons.I_Boots'
     RemoteRole=ROLE_DumbProxy
     Mesh=Mesh'Botpack.jboot'
     AmbientGlow=64
     bMeshCurvy=False
     CollisionRadius=22.000000
     CollisionHeight=14.000000
     MaxDesireability=0.5000
     ItemName="AntiGrav Boots"
}