// ====================================================================
// This script was quoted in part from Boom-boy. thx.
// reconstruction by zeal.
// Strong monster code unaltered except to keep naming convention
// ====================================================================

class MHMStrongMonster extends Mutator;

function PostBeginPlay()
{
	local ScriptedPawn S;

	Log(" ");
	Log("--- MHM MonsterHunt Strong Monster Mutator initialized.  by zeal=TUS=");
	Log("---  ");
	Log(" ");

	foreach AllActors(class'ScriptedPawn', S)
	{
		PowerUpMonster(S);
	}
	SetTimer(5.0,True);

	Super.PostBeginPlay();
}
function ModifyPlayer(Pawn Other)
{
	Super.ModifyPlayer(Other);
}


simulated function Timer()
{
	local ScriptedPawn S;
	local Pawn P;
	
	for ( P=Level.PawnList; P!=None; P=P.NextPawn )
	if ( P.IsA('TournamentPlayer') )
	{
		//BroadcastMessage("change "@P.DamageScaling);
		if(P.DamageScaling == 1.0)
		{
			P.DamageScaling = 1.5;
		}
	}

	foreach AllActors(class'ScriptedPawn', S)
	{
		SetMonsterWeapon(S);
	}
}
function AddMutator(Mutator M)
{
	Super.AddMutator(M);
}

function PowerUpMonster(ScriptedPawn S)
{
	local int StrongLevel;
	StrongLevel = 4;
	S.Aggressiveness *= StrongLevel;
	S.ReFireRate *= StrongLevel;
	S.CombatStyle *= StrongLevel;
	S.ProjectileSpeed *= StrongLevel;
	S.AccelRate *= StrongLevel;

	//S.fatness = S.Health;
	if (S.Health >= 500000) S.Health /= 10; // power down(lo


	if (S.IsA('Brute'))
	{
		Brute(S).WhipDamage += StrongLevel;
		Brute(S).WhipDamage += StrongLevel*10;
	}
	else if (S.IsA('Gasbag'))
	{
		Gasbag(S).PunchDamage += StrongLevel;
		Gasbag(S).PunchDamage += StrongLevel*10;
	}
	else if (S.IsA('Titan'))
	{
		Titan(S).PunchDamage += StrongLevel;
		Titan(S).PunchDamage += StrongLevel*10;
	}
	else if (S.IsA('Krall'))
	{
		Krall(S).StrikeDamage += StrongLevel;
		Krall(S).StrikeDamage += StrongLevel*10;
	}
	else if (S.IsA('Manta'))
	{
		Manta(S).StingDamage += StrongLevel;
		Manta(S).StingDamage += StrongLevel*10;
	}
	else if (S.IsA('Mercenary'))
	{
		Mercenary(S).PunchDamage += StrongLevel;
		Mercenary(S).PunchDamage += StrongLevel*10;
	}
	else if (S.IsA('Skaarj'))
	{
		Skaarj(S).ClawDamage += StrongLevel;
		Skaarj(S).ClawDamage += StrongLevel*10;
	}
	else if (S.IsA('Pupae'))
	{
		Pupae(S).BiteDamage += StrongLevel;
		Pupae(S).BiteDamage += StrongLevel*10;
	}
	else if (S.IsA('Queen'))
	{
		Queen(S).ClawDamage += StrongLevel;
		Queen(S).ClawDamage += StrongLevel*10;
	}
	else if (S.IsA('Slith'))
	{
		Slith(S).ClawDamage += StrongLevel;
		Slith(S).ClawDamage += StrongLevel*10;
	}
	else if (S.IsA('Warlord'))
	{
		Warlord(S).StrikeDamage += StrongLevel;
		Warlord(S).StrikeDamage += StrongLevel*10;
	}
}
function SetMonsterWeapon(ScriptedPawn S)
{

	if (S.IsA('Queen'))
	{
		switch(rand(6))
		{
		 case 0:
			S.RangedProjectile = class'UT_Grenade';
		 break;
		 case 1:
			S.RangedProjectile = class'RocketMk2';
		 break;
		 case 2:
			S.RangedProjectile = class'BioGlob';
		 break;
		 case 3:
			S.RangedProjectile = class'MHMWarShell';
		 break;
		 case 4:
			S.RangedProjectile = class'UTFlakShell';
		 break;
		 case 5:
			S.RangedProjectile = class'MHMWarShell2';
		 break;

		}

	}
	if (S.IsA('Brute'))
	{
		switch(rand(9))
		{
		 case 0:
			S.RangedProjectile = class'BioGlob';
		 break;
		 case 1:
		 case 2:
		 case 3:
			S.RangedProjectile = class'Razor2';
		 break;
		 case 4:
			S.RangedProjectile = class'Razor2Alt';
		 break;
		 case 5:
			S.RangedProjectile = class'MHMWarShell';
		 break;
		 case 6:
			S.RangedProjectile = class'UT_Grenade';
		 break;
		 case 7:
		 case 8:
			S.RangedProjectile = class'RocketMk2';
		 break;
		}
	}
	if (S.IsA('Gasbag'))
	{
		switch(rand(5))
		{
		 case 0:
			S.RangedProjectile = class'UTFlakShell';
		 break;
		 case 1:
		 case 2:
			S.RangedProjectile = class'ShockProj';
		 break;
		 case 3:
			S.RangedProjectile = class'RocketMk2';
		 break;
		 case 4:
			S.RangedProjectile = class'UT_Grenade';
		 break;
		}
	}
	if (S.IsA('Krall'))
	{
		switch(rand(7))
		{
		 case 0:
		 case 1:
		 case 2:
			S.RangedProjectile = class'ShockProj';
		 break;
		 case 3:
		 case 4:
			S.RangedProjectile = class'DAmmo4';
		 break;
		 case 5:
			S.RangedProjectile = class'DAmmo5';
		 break;
		 case 6:
			S.RangedProjectile = class'MHMWarShell';
		 break;
		}
	}
	if (S.IsA('Mercenary'))
	{
		switch(rand(4))
		{
		 case 0:
		 case 1:
			S.RangedProjectile = class'RocketMk2';
		 break;
		 case 2:
		 case 3:
			S.RangedProjectile = class'UT_Grenade';
		 break;
		}
	}
	if (S.IsA('Skaarj'))
	{
		switch(rand(7))
		{
		 case 0:
		 case 1:
			S.RangedProjectile = class'DAmmo4';
		 break;
		 case 2:
		 case 3:
			S.RangedProjectile = class'ShockProj';
		 break;
		 case 4:
		 case 5:
			S.RangedProjectile = class'RocketMk2';
		 break;
		 case 6:
			S.RangedProjectile = class'MHMWarShell';
		 break;
		}

	}
	if (S.IsA('Slith'))
	{
		switch(rand(4))
		{
		 case 0:
		 case 1:
			S.RangedProjectile = class'BioGlob';
		 break;
		 case 2:
		 case 3:
			S.RangedProjectile = class'UT_BioGel';
		 break;
		}
	}
	if (S.IsA('Tentacle'))
	{
		switch(rand(6))
		{
		 case 0:
		 case 1:
			S.RangedProjectile = class'RocketMk2';
		 break;
		 case 2:
		 case 3:
			S.RangedProjectile = class'BioGlob';
		 break;
		 case 4:
		 case 5:
			S.RangedProjectile = class'UT_Grenade';
		 break;
		}
	}
	if (S.IsA('Warlord'))
	{
		switch(rand(5))
		{
		 case 0:
			S.RangedProjectile = class'MHMWarShell';
		 break;
		 case 1:
			S.RangedProjectile = class'Razor2Alt';
		 break;
		 case 2:
			S.RangedProjectile = class'Dammo4';
		 break;
		 case 3:
			S.RangedProjectile = class'MHMWarshell2';
		 break;
		 case 3:
			S.RangedProjectile = class'RocketMk2';
		 break;
		 case 4:
			S.RangedProjectile = class'UTFlakShell';
		 break;
		}
	}

}

defaultproperties
{
}
