//=============================================================================
// PinataClientWindow. 
//=============================================================================
class PinataClientWindow expands UWindowDialogClientWindow config;

var UWindowComboControl gamemode;
var UWindowCheckBox checkbox;
var UWindowSmallButton CloseButton;
var UWindowSmallCloseButton CancelButton;

//Pinata config file variables
var() config bool noWeapons;
var() config bool noPowerups;
var() config bool HealthDrop;

function Created()
{
	Super.Created();
	
	// Combo box.
	gamemode = UWindowComboControl( CreateControl( class'UWindowComboControl', 10, 10, 200, 1 ) );
	gamemode.SetText( "Game Mode: " );
	gamemode.SetFont(F_Normal);
	gamemode.SetEditable( FALSE );
	gamemode.EditBoxWidth = 115;
	gamemode.AddItem("Drop All", "1");
	gamemode.AddItem("Drop PowerUps Only", "2");
	gamemode.AddItem("Drop Weapons Only", "3");
	
	if (noWeapons)
		gamemode.SetValue ("Drop PowerUps Only","2");
	else if (noPowerups)
		gamemode.SetValue ("Drop Weapons Only","3");
	else 
		gamemode.SetValue ("Drop All","1");	
	
	checkbox = UWindowCheckBox(CreateControl(class'UWindowCheckBox', 10, 45, 150, 1));
	checkbox.SetText("Random Health Drop");
	checkbox.bChecked = HealthDrop;

	CloseButton = UWindowSmallButton(CreateWindow(class'UWindowSmallButton', 94 , 80, 48, 16));
	CloseButton.SetText( "Close" );
	CloseButton.NotifyWindow = Self; 

	// Cancel button
	CancelButton = UWindowSmallCloseButton(CreateWindow(class'UWindowSmallCloseButton', 152, 80, 48, 16));
	CancelButton.SetText( "Cancel" );
}

function Notify( UWindowDialogControl C, byte E )
{
	local int mode;
	Super.Notify( C, E );

	switch(E)
	{
		case DE_Change:
			switch(C)
			{
				case gamemode:
					mode = int(gamemode.GetValue2());
					
					noPowerups = false;
					noWeapons = false;													
					
					if (mode==3)
						noPowerups = true;					
					else if (mode==2) 
						noWeapons = true;
						
					class'MHMPinata'.static.StaticSaveConfig();
					break;					
				case checkbox:
					if (checkbox.bChecked) 
						HealthDrop = true;
					else
						HealthDrop = false;
					class'MHMPinata'.static.StaticSaveConfig();			
					break;	
			}
		case DE_Click:
			switch(C)
			{
				case CloseButton:					
					SaveConfig();
					ParentWindow.Close();
					break;
			}
	}
}

defaultproperties
{
}
